#include "scene.h"
#include "ppc.h"
#include "linesegment.h"
#include "triangle.h"
#include "tmesh.h"

Scene *scene;

#include <iostream>

using namespace std;


Scene::Scene() {

  gui = new GUI();
  gui->show();

  int u0 = 0;
  int v0 = 0;
  int w = 640;
  int h = 480;
  fb = new FrameBuffer(u0, v0, w, h);
  unsigned int colors[2] = {0xFFFFFFFF, 0xFF0000FF};
  int cw = 32;
  fb->SetChecker(cw, colors);
  fb->label("Frame Buffer");
  fb->show();

  gui->uiw->position(fb->w+20, 40);

}

void Scene::DBG() {

  int w = fb->w;
  int h = fb->h;
  float hfov = 25.0f;
  PPC ppc(hfov, w, h);

  fb->ClearBuffers();

#if 0
  fb->Set(0xFFFFFFFF);
  V3 V0(20.0f, 400.0f, 1.0f);
  V3 V1(520.0f, 440.0f, 1.0f);
  V3 V2(150.0f, 100.0f, 1.0f);
  V3 V33(601.0f, 100.0f, 1.0f);
  Triangle tri(V0, V1, V2);
  tri.Rasterize(fb, 0xFF00AAFF);
  Triangle tri2(V1, V33, V2);
  tri2.Rasterize(fb, 0xFFFF0000);
  fb->redraw();

  return;
#endif

  TMesh tm;
  tm.Load("geometry/teapot1K.bin");
  tm.Scale(20.0f);
  tm.TranslateTo(V3(0.0f, 0.0f, -50.0f));
  tm.RenderFilled(&ppc, fb);
//  tm.RenderPoints(11, 0xFF0000FF, &ppc, fb);
//  tm.RenderWF(0xFFFF0000, &ppc, fb);

  fb->redraw();

  return;

  V3 cube[8];
  cube[0] = V3(-5.0f, 5.0f, -40.f);
  cube[1] = V3(-5.0f, -5.0f, -40.f);
  cube[2] = V3(5.0f, -5.0f, -40.f);
  cube[3] = V3(5.0f, 5.0f, -40.f);
  cube[4] = V3(-5.0f, 5.0f, -50.f);
  cube[5] = V3(-5.0f, -5.0f, -50.f);
  cube[6] = V3(5.0f, -5.0f, -50.f);
  cube[7] = V3(5.0f, 5.0f, -50.f);
  V3 projCube[8];
  for (int i = 0; i < 8; i++) {
    ppc.Project(cube[i], projCube[i]);
  }
  for (int i = 0; i < 4; i++) {
    int _i = (i+1)%4;
    {
      LineSegment ls(projCube[i], projCube[_i]);
      ls.Draw2D(fb, 0xFF000000);
    }
    {
      LineSegment ls(projCube[4+i], projCube[4+_i]);
      ls.Draw2D(fb, 0xFF000000);
    }
    {
      LineSegment ls(projCube[i], projCube[i+4]);
      ls.Draw2D(fb, 0xFF000000);
    }
  }
  fb->redraw();
  return;

/*
  FrameBuffer *im = new FrameBuffer;
  im->Load("images/imageSmall.tif");
  im->show();
  return;
*/

  {
    V3 C(120.0f, 35.0f, 0.0f);
    float r = 23.45f;
    int left = (int) (C[0]-r);
    int right = (int) (C[0]+r);
    int top = (int) (C[1]-r);
    int bottom = (int) (C[1]+r);
    for (int v = top; v <= bottom; v++) {
      for (int u = left; u <= right; u++) {
        V3 P(.5f+(int)u, .5f+(int)v, 0.0f);
        if ((P-C).Length() > r)
          continue;
        fb->SetGuarded(.5f+(int)u, .5f+(int)v, 0xFF00FF00);
      }
    }
    fb->redraw();

    return;
  }

  fb->Load("images/imageSmall.tif");
  fb->redraw();
  FrameBuffer *edgeMap = 0;
  fb->EdgeMap(edgeMap);
  edgeMap->show();
  return;

}

void FrameBuffer::ClearBuffers() {

  Set(0xFFFFFFFF);
  for (int i = 0; i < w*h; i++)
    zb[i] = 0.0f;

}
